# AllOverIt
[![NuGet](https://img.shields.io/nuget/v/AllOverIt?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt/)

A general purpose library containing a variety of classes, utilities, and helpers to fill in regularly occuring software development gaps.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |

Refer to the online [Documentation](https://mjfreelancing.github.io/AllOverIt/) for usage information.


# AllOverIt.AspNetCore
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.AspNetCore?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.AspNetCore/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.AspNetCore?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.AspNetCore/)

Provides additional features for use in ASP .NET Core applications.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    No     |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Assertion
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Assertion?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Assertion/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Assertion?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Assertion/)

A library of pre and post condition assertion helper methods.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Aws.AppSync.Client
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Aws.AppSync.Client?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Aws.AppSync.Client/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Aws.AppSync.Client?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Aws.AppSync.Client/)

Provides an AWS AppSync Graphql Subscription client.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Aws.Cdk.AppSync
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Aws.Cdk.AppSync?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Aws.Cdk.AppSync/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Aws.Cdk.AppSync?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Aws.Cdk.AppSync/)

Includes a code-first graphql schema generator that also provides support for binding resolvers to None, Http, and Lamda datasources.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    No \*  |
| netcoreapp3.1  |    Yes    |
| net5.0         |    No \*  |
| net6.0         |    No \*  |
| net7.0         |    No \*  |

\* Although not explicitly built for all platforms, the AWS CDK supports Net Core 3.1 and above.


# AllOverIt.Csv
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Csv?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Csv/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Csv?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Csv/)

A library to assist with CSV export using CsvHelper.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.DependencyInjection
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.DependencyInjection?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.DependencyInjection/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.DependencyInjection?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.DependencyInjection/)

A library containing useful dependency injection related utilities.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.EntityFrameworkCore
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.EntityFrameworkCore?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.EntityFrameworkCore/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.EntityFrameworkCore?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.EntityFrameworkCore/)

Provides additional features for use in Entity Framework Core applications.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.EntityFrameworkCore.Pagination
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.EntityFrameworkCore.Pagination?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.EntityFrameworkCore.Pagination/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.EntityFrameworkCore.Pagination?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.EntityFrameworkCore.Pagination/)

A library providing pagination utilities for use with Entity Framework Core.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Evaluator
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Evaluator?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Evaluator/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Evaluator?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Evaluator/)

A library designed to parse and evaluate mathemtical expressions. It provides support for custom operators, functions and includes constant, mutable, immutable, lazy, and delegate based variables to satisfy just about any requirement.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Filtering
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Filtering?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Filtering/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Filtering?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Filtering/)

A library providing queryable filtering utilities.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Fixture
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Fixture?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Fixture/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Fixture?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Fixture/)

Contains a base Fixture class that includes a number of helpful utility methods.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Fixture.FakeItEasy
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Fixture.FakeItEasy?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Fixture.FakeItEasy/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Fixture.FakeItEasy?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Fixture.FakeItEasy/)

Extends **AllOverIt.Fixture** to assist with the creation of single/multiple stubs and fakes.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.GenericHost
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.GenericHost?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.GenericHost/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.GenericHost?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.GenericHost/)

Provides the ability to quickly create console applications that support dependency injection without being concerned with all of the ceremony.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Pagination
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Pagination?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Pagination/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Pagination?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Pagination/)

A library providing queryable pagination utilities.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Reactive
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Reactive?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Reactive/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Reactive?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Reactive/)

Provides utility extensions for use with System.Reactive.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.ReactiveUI
[![NuGet](https://img.shields.io/nuget/v/AllOverItUI.Reactive?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.ReactiveUI/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverItUI.Reactive?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.ReactiveUI/)

Provides utility extensions for use with ReactiveUI.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Serialization
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Serialization?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Serialization?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization/)

Provides common serialization helpers.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Serialization.Abstractions
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Serialization.Abstractions?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.Abstractions/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Serialization.Abstractions?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.Abstractions/)

Provides abstractions for JSON serialization.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Serialization.NewtonSoftJson
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Serialization.NewtonSoftJson?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.NewtonSoftJson/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Serialization.NewtonSoftJson?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.NewtonSoftJson/)

A JSON serialization wrapper around NewtsonSoft.Json (an implementation for AllOverIt.Serialization.Abstractions).

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Serialization.SystemTextJson
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Serialization.SystemTextJson?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.SystemTextJson/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Serialization.SystemTextJson?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Serialization.SystemTextJson/)

A JSON serialization wrapper around System.Text.Json (an implementation for AllOverIt.Serialization.Abstractions).

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |


# AllOverIt.Validation
[![NuGet](https://img.shields.io/nuget/v/AllOverIt.Validation?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Validation/)
[![NuGet](https://img.shields.io/nuget/dt/AllOverIt.Validation?style=for-the-badge)](https://www.nuget.org/packages/AllOverIt.Validation/)

Provides additional validators and extensions for use with FluentValidation.

| Target         | Supported |
|----------------|-----------|
| netstandard2.1 |    Yes    |
| netcoreapp3.1  |    Yes    |
| net5.0         |    Yes    |
| net6.0         |    Yes    |
| net7.0         |    Yes    |
